<?
/*
	This file is a shared library and contains code that is used
	by more than one website. Everything that is specific to a
	certain website must go in local.inc.

	If you really need to change functions in this file, please
	add them to the end of this file.
*/
	/* Turn on output buffering */
	ob_start();

	$ENV=array();
//	$ENV=$GLOBALS;

	/* getting parameters */
	if(!empty($HTTP_POST_VARS)) 
		$in=$HTTP_POST_VARS;
	else
		$in=$HTTP_GET_VARS;

	/* base variables */ 
	$INDEXFILE='index.php';
	$ENV['DOCUMENT_ROOT']=getenv('DOCUMENT_ROOT');
	$ENV['HTTPS']=getenv('HTTPS');
	$ENV['HTTP_HOST']=getenv('HTTP_HOST');
	$ENV['HTTP_REFERER']=getenv('HTTP_REFERER');
	$ENV['HTTP_USER_AGENT']=getenv('HTTP_USER_AGENT');
	$ENV['PATH_TRANSLATED']=getenv('PATH_TRANSLATED');
	$ENV['PHP_AUTH_PW']=getenv('PHP_AUTH_PW');
	$ENV['PHP_AUTH_TYPE']=getenv('PHP_AUTH_TYPE');
	$ENV['PHP_AUTH_USER']=getenv('PHP_AUTH_USER');
	$ENV['PHP_SELF']=getenv('PHP_SELF');
	$ENV['REMOTE_ADDR']=getenv('REMOTE_ADDR');
	$ENV['REMOTE_HOST']=getenv('REMOTE_HOST');
	$ENV['REMOTE_USER']=getenv('REMOTE_USER');
	$ENV['REQUEST_URI']=getenv('REQUEST_URI');
	list($ENV['REQUEST_NAME'])=split('[#?]',$ENV['REQUEST_URI']);
	$ENV['REQUEST_NAME']=str_replace($INDEXFILE,'',$ENV['REQUEST_NAME']);
	$ENV['SCRIPT_NAME']=getenv('SCRIPT_NAME');
	$ENV['SCRIPT_NAME']=str_replace($INDEXFILE,'',$ENV['SCRIPT_NAME']);
	$ENV['SERVER_ADMIN']=getenv('SERVER_ADMIN');
	$ENV['SERVER_NAME']=getenv('SERVER_NAME');
	$ENV['SERVER_SOFTWARE']=getenv('SERVER_SOFTWARE');
	$ENV['QUERY_STRING']=getenv('QUERY_STRING');

	/* This didn't work ;-( */
//	if (isset($PHP_AUTH_USER)) $ENV['REMOTE_USER']=$PHP_USER_AUTH;

//	$DIRNAME=dirname($ENV[SCRIPT_NAME]."file");
	$ENV['DIRNAME']=dirname($ENV['REQUEST_NAME'].'file');
	if ($ENV['DIRNAME']=='') $ENV['DIRNAME']='/';
	$MANPAGE='http://www.rivertown.net/cgi-bin/man-cgi?';
	$NRHEADLINES=8;
//	$CSS=false;
	$CSS=true;
	$IE4=$IE3=$NS4=$NS3=$WIN=false;
//	$NS4=1;


	/* initializing arrays */
	$descr=$title=$config=array();

	function _errorhandler($nr,$str,$file,$line,$context) {
		global $ENV;
//		echo "Hi there !!<br><big><b>Error-type: $nr</b></big><br>";
		$user_errors=array(E_USER_ERROR, E_ERROR, E_USER_NOTICE, E_PARSE);
		if (!in_array($nr,$user_errors)) return 0;
//		$level=(E_NOTICE | E_USER_NOTICE);
//		if ($nr & $level) return 0;
//		echo "errorhandler($nr,$str,$file,$line,$context)<br>";
		$type=array(
			E_ERROR				=> "Error",				// 1
			E_WARNING			=> "Warning",			// 2
			E_PARSE				=> "Parse Error",		// 4
			E_NOTICE			=> "Notice",			// 8
			E_CORE_ERROR		=> "Core Error",		// 16
			E_CORE_WARNING		=> "Core Warning",		// 32
			E_COMPILE_ERROR		=> "Compile Error",		// 64
			E_COMPILE_WARNING	=> "Compile Warning",	// 128
			E_USER_ERROR		=> "User Error",		// 256
			E_USER_WARNING		=> "User Warning",		// 512
			E_USER_NOTICE		=> "User Notice",		// 1024
		);
		if ($ENV['error_body']=="") {
			$ENV['error_subject']="[WEB] PHP errors in http://$ENV[SERVER_NAME]$ENV[REQUEST_URI]";
			$ENV['error_body']="referer: $ENV[HTTP_REFERER]\n".
				"bad link: http://$ENV[SERVER_NAME]$ENV[REQUEST_URI]\n".
				"http_user_agent: $ENV[HTTP_USER_AGENT]\n".
				"remote_addr: $ENV[REMOTE_ADDR] ($ENV[REMOTE_HOST])\n\n";
		}
		$ENV['error_body'].="\tPHP $type[$nr] [$nr]: $str "."at line $line in $file\n\n";
//                              print_r($context)."\n\n";
		if($nr==E_ERROR) {
			_foot();
			include("mod_append.inc");
		}
	}

	if (empty($in["debug"])) {
		set_error_handler("_errorhandler");
/*		if (set_error_handler("_errorhandler")) 
			error_reporting(E_ALL ^ E_PARSE);	// E_PARSE doesn't use _errorHandler
		else  */
			error_reporting(0); 
	} else {
		if ($in["debug"]=="all")
			error_reporting(E_ALL);
		else 
			error_reporting(E_ALL ^ E_NOTICE);
	}
	
	/* default settings (meta-tags and order) */
	$meta["keywords"]="";
	$meta["description"]="";
	$meta["robots"]="index,follow";
	$meta["author"]="Dag Wieers";
	$meta["copyright"]="&copy; 1995-2003 Dag Wieers, dag@wieers.com. All rights reserved.";
	$meta["email"]="dag@wieers.com";
//	$meta["generator"]="vim+php+ht-dig+apache+linux=Open Source at its best.";
	$meta["language"]="English";

	$config["charset"]="iso-8859-15";
	$config['internal_hosts']='^$';
	$config["lang"]="en";
	$config["path"]="/";

	$headers=getallheaders();

	/* Search module and load it */
	function _searchModule($file) {
		global $ENV, $config;
		$t=explode('/',$ENV['DIRNAME']);
		for($i=1;$i<=count($t);$i++) {
			$p="";
			for($j=1;$j<count($t)+1-$i;$j++) $p.='/'.$t[$j];
			if (is_readable("$ENV[DOCUMENT_ROOT]$p/$file")) {
				if (!empty($in["debug"]))
					echo "<!-- Module $file searched and loaded -->";
				include_once("$ENV[DOCUMENT_ROOT]$p/$file");
				return 0;
			}
		}
		return 1;
	}

	function _loadModule($file) {
		global $ENV, $config;
		if (is_readable("$ENV[DOCUMENT_ROOT]/$config[path]$file")) {
			if (!empty($in["debug"]))
				echo "<!-- Module $file loaded -->";
			include_once("$ENV[DOCUMENT_ROOT]/$config[path]$file");
			return 0;
		} else {
			if (!empty($in["debug"]))
				echo "<!-- Module $file loaded -->";
			include_once($file);
		}
		return 1;
	}

	/* Load site-specific stuff */
	_searchModule('cfg_local.inc');
	setlocale(LC_ALL,$config['lang']);
	_setRelDirname();

	/* determine browser */
/*	if (!isset($ENV[HTTP_USER_AGENT])) $ENV[HTTP_USER_AGENT]="none";
	if (ereg("Win",$ENV[HTTP_USER_AGENT],$version)) $WIN=true;
	if (ereg("MSIE.([0-9])",$ENV[HTTP_USER_AGENT],$version)) {
		$ver=(int)$version[1];
		if ($ver>=4) $IE4=true;
		elseif ($ver==3) $IE3=true;
	} elseif (ereg("ozilla.([0-9])",$ENV[HTTP_USER_AGENT],$version)) {
		$ver=(int)$version[1];
		if ($ver>=4) $NS4=true; 
		elseif($ver==3) $NS3=true; 
	}*/

	/* determine browser */
//	if (!isset($ENV[HTTP_USER_AGENT])) $ENV[HTTP_USER_AGENT]="none";
//	if (eregi("Win",$ENV[HTTP_USER_AGENT])) $WIN=true;
	if (preg_match('/MSIE [4-9]/i',$ENV['HTTP_USER_AGENT'])) {
		$IE4=true;
	} elseif (preg_match('/MSIE 3/i',$ENV['HTTP_USER_AGENT'])) {
		$IE3=true;
	} elseif (preg_match('/ozilla\/[5-9]/i',$ENV['HTTP_USER_AGENT'])) {
		$NS6=true;
	} elseif (preg_match('/ozilla\/4/i',$ENV['HTTP_USER_AGENT'])) {
		$NS4=true; 
	} elseif (preg_match('/ozilla\/3/i',$ENV['HTTP_USER_AGENT'])) {
		$NS3=true; 
	}

	/* get real doc-root */
/*
	if (ereg("^/nl/",$ENV['REQUEST_NAME'])) 
	 $config['path']="/nl/";
	elseif (ereg("^/fr/",$ENV['REQUEST_NAME'])) 
	 $config['path']="/fr/";
	elseif (ereg("^/de/",$ENV['REQUEST_NAME'])) 
	 $config['path']="/de/";
*/

	/* read the right library */
//require($config['path']."linux-local.inc");

	function _isPrivate() {
		global $ENV, $config;
		if (($ENV['REMOTE_HOST']!='' and preg_match("/$config[internal_hosts]/i",$ENV['REMOTE_HOST'])) or
			(preg_match("/$config[internal_hosts]/i",$ENV['REMOTE_ADDR'])))
			return 1;
		return 0; 
	}

	function _setTitle($file,$name) {
		global $title;
		if (empty($title[$name])) 
			$title[$name]=_readTitle($file);
	}

	function _readTitle(/* $file,$name */) {
		global $title;
		$numargs=func_num_args();
        $file=func_get_arg(0);
		if (!empty($title[$file]))
			return $title[$file];
		if (is_file($file)) {
			if (is_readable($file))
				$name=_getTitle($file);
		} else {
			if (is_readable("$file/.title"))
				$name=rtrim(current(file("$file/.title")));
			elseif (is_readable("$file/index.php"))
				$name=_getTitle("$file/index.php");
			elseif (is_readable("$file/index.html"))
				$name=_getTitle("$file/index.html");
			elseif (is_readable("$file/index.cgi"))
				$name=_getTitle("$file/index.cgi");
		}
		if (empty($name)) {
			if ($numargs==2) {
				$name=func_get_arg(1);
				if ($name!="") $name="[$name]";
			} else {
				$name="[".basename($file)."]";
			}
		}
		return $name;
	}

	function _getTitle($file) {
		if ($fd=fopen($file,"r")) {
			$contents=fread($fd, 2048);
			fclose ($fd);
			if(eregi('_head\([\'\"]([^\"]*)[\'\"]\)',$contents,$regs) or
				 eregi("<title\n?>([^<]*)</title\n?>",$contents,$regs)) {
				return strip_tags($regs[1]);
			}
		}
		return false;
	}

	function _setDescr($file,$desc) {
		global $descr;
		if (empty($descr[$file])) 
			$descr[$file]=$desc;
	}

	function _readDescr($file) {
		global $descr, $title, $config, $ENV;
		$desc=false;
		if (!empty($descr[$file]))
			return $descr[$file];
		$full="$ENV[DOCUMENT_ROOT]/$file";
		if (is_file($full)) {
			if (is_readable($full))
				$desc=_getDescr($full);
		} else {
			if (is_readable("$full/.descr"))
				$desc=rtrim(current(file("$full/.descr")));
			elseif (is_readable("$full/index.php"))
				$desc=_getDescr("$full/index.php");
			elseif (is_readable("$full/.readme"))
				$desc=_getDescr("$full/.readme");
		}
		if (!$desc) {
			if (!empty($title[$file]))
				return $title[$file];
		}
		$descr[$file]=$desc;
		return $desc;
	}

	function _getDescr($file) {
		global $title;
		if ($fd=fopen($file,"r")) {
			$contents=fread($fd, 2048);
			fclose ($fd);
			if(eregi('\$meta\[[\"]description[\"]\]=[\"]([^\"]*)[\"]',$contents,$regs)
//				or preg_match('/<div class="intro">(.*?)<\/div>/s',$contents,$regs)
				)
				return strip_tags($regs[1]);
			elseif (!empty($title[$file]))
				return $title[$file];
		}
		return false;
	}

	function _ltrim($str,$charlist) {
		return substr($str,strspn($str,$charlist));
	}

	function _rtrim($str,$charlist) {
		$rev=strrev($str);
		$rev=substr($rev,strspn($rev,$charlist));
		return strrev($rev);
	}

	function _debugArray($aname,$array) {
	 echo "\n<!-- \$$aname -->\n";
	 if (isset($array)) {
		reset($array);
		while (list($name,$value)=each($array))
		 echo "<!-- \$$aname"."[\"$name\"]=\"$value\" -->\n";
	 }
	}

	/* Clean up $config[path] */
	function _setRelDirname() {
		global $ENV,$config;
		$config['path']=_rtrim($config['path'],'/');
		if ($config['path'] != '') {
			$ENV['RELDIRNAME']='/'._ltrim(str_replace($config['path'],'',$ENV['DIRNAME']),'/');
		} else {
			$ENV['RELDIRNAME']=$ENV['DIRNAME'];
		}
	}

	function _debug() {
		global $in, $config, $descr, $menu, $title, $in, $headers, $ENV, $GLOBALS;
		if (!empty($in['debug'])) {
			echo "<!-- debug information -->\n";
			_debugArray('config',$config);
			_debugArray('descr',$descr);
			_debugArray('in',$in);
			_debugArray('title',$title);
			_debugArray('headers',$headers);
			_debugArray('ENV',$ENV);
			echo "<!-- ------------------- -->\n\n";
		}
	}

	function spc($width,$height,$alt) {
	 echo "<img src=\"/images/spacer.gif\" width=\"$width\" height=\"$height\" border=\"0\" alt=\"$alt\" hspace=\"0\" vspace=\"0\">";
	}

	function _getLastUpdated() {
	 global $meta;
	 if (!empty($meta['id']) and ereg('Id: .+,v .+ ([0-9]{4})/([0-9]{2})/([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2}) .+ Exp ',$meta['id'],$date))
		return mktime($date[4],$date[5],$date[6],$date[2],$date[3],$date[1]);
	}

	function _lastUpdated($file) {
		global $config;
		if ($file) {
			if(is_file($file))
				echo '<small><b>Updated '.gmdate('d F Y',filemtime($file))."</b></small>\n";
			else
				echo '<small><b>File is missing!</b></small>';
		} else {
			if ($date=_getLastUpdated())
				echo "<div id=\"lastupdated\">".$config['last updated'].strftime("%d %B %Y",$date)."</div>\n";
		}
	}

	/* creates a filename of a string */
	function _createName($title) {
	 $name="";
	 $title=strtolower($title);
	 for ($i=0;$i<strlen($title);$i++) {
		$chr=substr($title,$i,1);
		if ((ord($chr)>=ord('a') and ord($chr)<=ord('z')) or
				(ord($chr)>=ord('0') and ord($chr)<=ord('9') and $name!=''))
			$name.=$chr;
		elseif($chr==" ")
			$name.="-";
	 }
	 return $name;
	}

	_debug();

/* End of shared stuff. */

/* Move modified functions below and change them. */
?>
